Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 463622 (CVE-2013-2264) - <net-misc/asterisk-{1.8.20.2,11.2.2}: Multiple Vulnerabilities (CVE-2013-{2264,2685,2686})
Summary: <net-misc/asterisk-{1.8.20.2,11.2.2}: Multiple Vulnerabilities (CVE-2013-{226...
Status: RESOLVED FIXED
Alias: CVE-2013-2264
Product: Gentoo Security
Classification: Unclassified
Component: Vulnerabilities (show other bugs)
Hardware: All Linux
: Normal major (vote)
Assignee: Gentoo Security
URL: https://secunia.com/advisories/52776/
Whiteboard: B1 [glsa]
Keywords:
Depends on:
Blocks:
 
Reported: 2013-03-28 16:45 UTC by Agostino Sarubbo
Modified: 2014-01-21 04:40 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Agostino Sarubbo gentoo-dev 2013-03-28 16:45:08 UTC
From ${URL} :

Description
A weakness and two vulnerabilities have been reported in Asterisk, which can be exploited by 
malicious people to determine valid usernames, cause a DoS (Denial of Service), and compromise a 
vulnerable system.

1) A boundary error in the "h264_format_attr_sdp_parse()" function (res/res_format_attr_h264.c) 
when parsing attribute resource for H.264 videos can be exploited to cause a stack-based buffer 
overflow via a specially crafted SDP header.

Successful exploitation of this vulnerability may allow execution of arbitrary code.

2) An error within the "ast_http_get_post_vars()" function (main/http.c) when parsing 
Content-Length values in HTTP POST requests can be exploited to exhaust available memory and 
disrupt the service.

3) The application sends different responses when using a valid or an invalid username in INVITE, 
SUBSCRIBE, and REGISTER messages. This can be exploited to determine valid usernames by sending 
specially crafted INVITE, SUBSCRIBE, and REGISTER messages.

Successful exploitation of this vulnerability requires alwaysauthreject to be enabled, allowguest 
to be disable, and autocreatepeer to be disabled.

The vulnerabilities are reported in versions prior to 11.2.2.


Solution
Update to version 11.2.2.

Provided and/or discovered by
1) Ulf Härnhammar
2) Christoph Hebeisen, TELUS Security Labs
3) Walter Doekes, OSSO B.V.

Original Advisory
http://downloads.asterisk.org/pub/security/AST-2013-001.html
http://downloads.asterisk.org/pub/security/AST-2013-002.html
http://downloads.asterisk.org/pub/security/AST-2013-003.html

https://issues.asterisk.org/jira/browse/ASTERISK-20901
https://issues.asterisk.org/jira/browse/ASTERISK-20967
https://issues.asterisk.org/jira/browse/ASTERISK-21013
Comment 1 Tony Vroon gentoo-dev 2013-03-28 17:17:42 UTC
+*asterisk-11.2.2 (28 Mar 2013)
+*asterisk-1.8.20.2 (28 Mar 2013)
+
+  28 Mar 2013; Tony Vroon <chainsaw@gentoo.org> -asterisk-1.8.19.1.ebuild,
+  -asterisk-1.8.20.0.ebuild, +asterisk-1.8.20.2.ebuild,
+  -asterisk-11.1.2.ebuild, -asterisk-11.2.0.ebuild, -asterisk-11.2.1-r2.ebuild,
+  +asterisk-11.2.2.ebuild:
+  Security upgrade to address a boundary error in H264 video SDP handling,
+  naive Content-Length variable parsing in HTTP POST requests and an
+  information leak around account existence for the SIP channel driver.

Arches, please test & mark stable:
=net-misc/asterisk-1.8.2.20
=net-misc/asterisk-11.2.2

Target keywords: amd64 x86

Once installed with USE="samples" to gain default configuration files, please try to stop & start the daemon three times in sequence. Unless further test hardware is available, this is a suitable and complete test.
Comment 2 Agostino Sarubbo gentoo-dev 2013-03-30 12:08:26 UTC
amd64 stable
Comment 3 Agostino Sarubbo gentoo-dev 2013-03-30 12:09:12 UTC
x86 stable
Comment 4 Sean Amoss (RETIRED) gentoo-dev Security 2013-03-30 12:58:11 UTC
Updated existing GLSA draft.
Comment 5 Tony Vroon gentoo-dev 2013-03-30 13:13:01 UTC
+  30 Mar 2013; Tony Vroon <chainsaw@gentoo.org> -asterisk-1.8.20.1.ebuild,
+  -asterisk-11.2.1.ebuild:
+  Remove vulnerable ebuilds after stabling, for security bug #463622.
Comment 6 GLSAMaker/CVETool Bot gentoo-dev 2013-04-11 16:37:21 UTC
CVE-2013-2686 (http://nvd.nist.gov/nvd.cfm?cvename=CVE-2013-2686):
  main/http.c in the HTTP server in Asterisk Open Source 1.8.x before
  1.8.20.2, 10.x before 10.12.2, and 11.x before 11.2.2; Certified Asterisk
  1.8.15 before 1.8.15-cert2; and Asterisk Digiumphones 10.x-digiumphones
  before 10.12.2-digiumphones does not properly restrict Content-Length
  values, which allows remote attackers to conduct stack-consumption attacks
  and cause a denial of service (daemon crash) via a crafted HTTP POST
  request.  NOTE: this vulnerability exists because of an incorrect fix for
  CVE-2012-5976.

CVE-2013-2685 (http://nvd.nist.gov/nvd.cfm?cvename=CVE-2013-2685):
  Stack-based buffer overflow in res/res_format_attr_h264.c in Asterisk Open
  Source 11.x before 11.2.2 allows remote attackers to execute arbitrary code
  via a long sprop-parameter-sets H.264 media attribute in a SIP Session
  Description Protocol (SDP) header.

CVE-2013-2264 (http://nvd.nist.gov/nvd.cfm?cvename=CVE-2013-2264):
  The SIP channel driver in Asterisk Open Source 1.8.x before 1.8.20.2, 10.x
  before 10.12.2, and 11.x before 11.2.2; Certified Asterisk 1.8.15 before
  1.8.15-cert2; Asterisk Business Edition (BE) C.3.x before C.3.8.1; and
  Asterisk Digiumphones 10.x-digiumphones before 10.12.2-digiumphones exhibits
  different behavior for invalid INVITE, SUBSCRIBE, and REGISTER transactions
  depending on whether the user account exists, which allows remote attackers
  to enumerate account names by (1) reading HTTP status codes, (2) reading
  additional text in a 403 (aka Forbidden) response, or (3) observing whether
  certain retransmissions occur.
Comment 7 GLSAMaker/CVETool Bot gentoo-dev 2014-01-21 04:40:59 UTC
This issue was resolved and addressed in
 GLSA 201401-15 at http://security.gentoo.org/glsa/glsa-201401-15.xml
by GLSA coordinator Sergey Popov (pinkbyte).